/*
 * T1_T2.c
 *
 *  Created on: Nov 3, 2015
 *      Author: stsuyuki2
 */

#include "pan_tompkins.h"
#define wd  25
#define wd1 50

void T1_T2(int32_t* h, int32_t* signal, int32_t h_length, int32_t* T1, int32_t* T2, int32_t* true_h, int32_t* trueQ1_i, int32_t* trueS1_i){
	//static int32_t index[limit];
	//static int32_t Norm_ampl[limit];
	//static int32_t normTindx[limit];
	//static int32_t NormRange[limit];
	//static int32_t norm_amplt_size=0;
	//static int32_t norm_int_size=0;

	//array_init(Norm_ampl,limit);
	//array_init(normTindx,limit);

	//normal_amplt(h, h_length, signal, Norm_ampl, index, &norm_amplt_size);
	//normIntRange(h, h_length, NormRange, normTindx, &norm_int_size);

	int32_t stet = 0, i = 0, MaxAmp, MinAmp, MaxRange, MinRange, true_h2=0;

	//MaxAmp = Norm_ampl[max_no_bounds_checking(Norm_ampl, norm_amplt_size, 0)];
	//MinAmp = Norm_ampl[min_2(Norm_ampl, norm_amplt_size, 0)];

	//MaxRange = NormRange[max_no_bounds_checking(NormRange, norm_int_size, 0)];
	//MinRange = NormRange[min_2(NormRange, norm_int_size, 0)];

	while ((stet == 0)){// && (i <= limit)){

		if ((signal[h[i]] <= MaxAmp) && (signal[h[i]] >= MinAmp) && ((h[i+1] - h[i]) >= MinRange) && ((h[i+1] - h[i]) <= MaxRange)){
			*true_h = h[i];
			true_h2 = h[i+1]; //this is the index of the next fiducial point; we will need this to find T2

			stet = 1;
		}

		i++;
	}

	int32_t j1 = 0, Q1_i[wd];

	if (stet == 1){
		if(*true_h >= wd+1) {
		
			for (i = *true_h - wd; i < *true_h; i++){ //detect Q by examining wd iteration below the index of R

				if (abs_ecg(signal[i] - signal[i+1]) <= 30){
					Q1_i[j1] = i; //index of min
					j1++;
				}
			}
		}
	}

	//find the smallest value among the min array
	*trueQ1_i = Q1_i[0];

	int32_t k;

	for (k = 0; k < j1; k++){

		if (signal[*trueQ1_i] > signal[Q1_i[k]]){
			*trueQ1_i = Q1_i[k];
		}
	}

	int32_t S1_i[wd1];

	j1 = 0;

	for (i = *true_h; i < *true_h + wd1; i++){ //detect Q by examining wd iteration below the index of R

		if (abs_ecg(signal[i] - signal[i+1]) <= 100){
				S1_i[j1] = i; //index of min
				j1++;
		}
	}

	//find the smallest value among the min array
	*trueS1_i = S1_i[0];

	for (k = 0; k < j1; k++){

		if (signal[*trueS1_i] > signal[S1_i[k]]){
			*trueS1_i = S1_i[k];
		}
	}

	i=0;
	for(k=*trueQ1_i; k<=*trueS1_i; k++)
	{
		T1[i]=signal[k];
		i++;
	}

	i=0;
	for(k=*true_h; k<=true_h2; k++)
	{
		T2[i]=signal[k];
		i++;
	}		
}

//function [ T1,T2, true_h,trueQ1_i,trueS1_i ] = T1_T2(  h, signal)% make sure that "signal" is the first 5 minute of heart signal

