#include "pan_tompkins.h"

void lookback(int32_t* peaks_index, int32_t* peak_locs, int32_t* SPKF, int32_t* SPKI, int32_t* integration, int32_t THRESHOLD_F2, int32_t THRESHOLD_I2, int32_t* highpass, int32_t m_selected_RR, int32_t hp_5s_index, int32_t curr_index, int32_t* prev_peak)
{
	int32_t x_i_t, locs_temp;
	
	if(m_selected_RR!=0)
	{		
		if((curr_index - peak_locs[indexWrap(*peaks_index-1, peaks_size)]) >= ((166*m_selected_RR)/100)) //if the interval between the current peak and the last detected peak is at least 166% of the most recent RR-interval average
		{			
			locs_temp = max_2(integration, FS5, (curr_index-MS_400-peak_locs[indexWrap(*peaks_index-1, peaks_size)]), hp_5s_index); //search for the max in the previous interval of integration (400 ms)
			
			if(integration[locs_temp] > THRESHOLD_I2)
			{				
				x_i_t = max_2(highpass, FS5, MS_250+1, locs_temp);
				
				if(highpass[x_i_t] > THRESHOLD_F2)
				{
					peak_locs[indexWrap(*peaks_index, peaks_size)]=curr_index-x_i_t;
					*prev_peak=indexWrap(hp_5s_index+x_i_t,FS5);
					(*peaks_index)++;
					*SPKF = (highpass[x_i_t] + 3*(*SPKF))/4;
					*SPKI = (integration[locs_temp] + 3*(*SPKI))/4;
				}
			}	
		}
	}	
}
